﻿Imports System.Runtime.InteropServices
Imports System.Text
Imports Microsoft.Win32

Public Class DSOSDK_Class

    'Environment setting
    <DllImport("DSOSDK.dll", EntryPoint:="uDsoSDKSetEnv")> _
    Public Shared Function uDsoSDKSetEnv(ByVal iUsbSpeed As Integer, ByVal fDsoThread As Boolean, ByVal fDsoUnplugDetect As Boolean) As Boolean
    End Function

    <DllImport("DSOSDK.dll", EntryPoint:="uDsoSDKSetWorkDir")> _
    Public Shared Function uDsoSDKSetWorkDir(ByVal lpsDirectory As String) As Boolean
    End Function

    <DllImport("DSOSDK.dll", EntryPoint:="uDsoSDKGetErrorCodeEx")> _
    Public Shared Function uDsoSDKGetErrorCodeEx() As Integer
    End Function


    'Initial Functions
    <DllImport("DSOSDK.dll", EntryPoint:="uDsoSDKInit")> _
    Public Shared Function uDsoSDKInit() As Integer
    End Function

    <DllImport("DSOSDK.dll", EntryPoint:="uDsoSDKInitStack")> _
    Public Shared Function uDsoSDKInitStack(ByVal szSNString As String) As Integer
    End Function

    <DllImport("DSOSDK.dll", EntryPoint:="uDsoSDKSelectGroup")> _
    Public Shared Function uDsoSDKSelectGroup(ByVal iGroup As Integer) As Boolean
    End Function

    <DllImport("DSOSDK.dll", EntryPoint:="uDsoSDKShutdown")> _
    Public Shared Function uDsoSDKShutdown() As Boolean
    End Function


    'Get Hardware Information functions
    <DllImport("DSOSDK.dll", EntryPoint:="uDsoSDKGetVendorName")> _
    Public Shared Function uDsoSDKGetVendorName(ByVal iDevice As Integer, ByVal szVendorName As Byte()) As Boolean
    End Function

    <DllImport("DSOSDK.dll", EntryPoint:="uDsoSDKGetProductName")> _
    Public Shared Function uDsoSDKGetProductName(ByVal iDevice As Integer, ByVal szProductName As Byte()) As Boolean
    End Function

    <DllImport("DSOSDK.dll", EntryPoint:="uDsoSDKGetSerialNum")> _
    Public Shared Function uDsoSDKGetSerialNum(ByVal iDevice As Integer, ByVal szSerialNum As Byte()) As Boolean
    End Function

    <DllImport("DSOSDK.dll", EntryPoint:="uDsoSDKGetHwVer")> _
    Public Shared Function uDsoSDKGetHwVer(ByVal iDevice As Integer, ByRef piHwVer As IntPtr) As Boolean
    End Function

    <DllImport("DSOSDK.dll", EntryPoint:="uDsoSDKGetFwVer")> _
    Public Shared Function uDsoSDKGetFwVer(ByVal iDevice As Integer, ByRef piFwVer As IntPtr) As Boolean
    End Function

    <DllImport("DSOSDK.dll", EntryPoint:="uDsoSDKGetProductID")> _
    Public Shared Function uDsoSDKGetProductID(ByVal iDevice As Integer, ByRef piProductID As IntPtr) As Boolean
    End Function

    <DllImport("DSOSDK.dll", EntryPoint:="uDsoSDKGetCalibrationData")> _
    Public Shared Function uDsoSDKGetCalibrationData(ByVal iDevice As Integer, ByVal pdbValue As Double()) As Boolean
    End Function


    'Capture Parameter settings
    <DllImport("DSOSDK.dll", EntryPoint:="uDsoSDKReadIniFile")> _
    Public Shared Function uDsoSDKReadIniFile(ByVal szFilePathName As String) As Boolean
    End Function

    <DllImport("DSOSDK.dll", EntryPoint:="uDsoSDKSetBWL")> _
    Public Shared Function uDsoSDKSetBWL(ByVal iCh As Integer, ByVal iBwlFlag As Integer) As Boolean
    End Function

    <DllImport("DSOSDK.dll", EntryPoint:="uDsoSDKSetCoupling")> _
    Public Shared Function uDsoSDKSetCoupling(ByVal iCh As Integer, ByVal iCouplingFlag As Integer) As Boolean
    End Function

    <DllImport("DSOSDK.dll", EntryPoint:="uDsoSDKSetChOnOff")> _
    Public Shared Function uDsoSDKSetChOnOff(ByVal iCh As Integer, ByVal bChOn As Boolean) As Boolean
    End Function

    <DllImport("DSOSDK.dll", EntryPoint:="uDsoSDKSetAcquireMode")> _
    Public Shared Function uDsoSDKSetAcquireMode(ByVal iCh As Integer, ByVal iAcquireMode As Integer) As Boolean
    End Function

    <DllImport("DSOSDK.dll", EntryPoint:="uDsoSDKSetTrigCouple")> _
    Public Shared Function uDsoSDKSetTrigCouple(ByVal iTrigCoupleFlag As Integer) As Boolean
    End Function

    <DllImport("DSOSDK.dll", EntryPoint:="uDsoSDKSetVoltDiv")> _
    Public Shared Function uDsoSDKSetVoltDiv(ByVal iCh As Integer, ByVal iVoltDiv_uV As Integer) As Boolean
    End Function

    <DllImport("DSOSDK.dll", EntryPoint:="uDsoSDKSetVoltDivEx")> _
    Public Shared Function uDsoSDKSetVoltDivEx(ByVal iCh As Integer, ByVal iVoltDiv_uV As Integer) As Boolean
    End Function

    <DllImport("DSOSDK.dll", EntryPoint:="uDsoSDKSetVoltPos")> _
    Public Shared Function uDsoSDKSetVoltPos(ByVal iCh As Integer, ByVal iPosition As Integer) As Boolean
    End Function    '0~16000

    <DllImport("DSOSDK.dll", EntryPoint:="uDsoSDKSetVoltOfs")> _
    Public Shared Function uDsoSDKSetVoltOfs(ByVal iCh As Integer, ByVal iVoltOfs_uV As Integer) As Boolean
    End Function

    <DllImport("DSOSDK.dll", EntryPoint:="uDsoSDKSetHwBit")> _
    Public Shared Function uDsoSDKSetHwBit(ByVal iHwBit As Integer) As Boolean
    End Function

    <DllImport("DSOSDK.dll", EntryPoint:="uDsoSDKSetSampleRate")> _
    Public Shared Function uDsoSDKSetSampleRate(ByVal i64SampleRate As Int64) As Boolean
    End Function

    <DllImport("DSOSDK.dll", EntryPoint:="uDsoSDKSetRecordLength")> _
    Public Shared Function uDsoSDKSetRecordLength(ByVal iRecordLength As Integer) As Boolean
    End Function

    <DllImport("DSOSDK.dll", EntryPoint:="uDsoSDKSetWaitMode")> _
    Public Shared Function uDsoSDKSetWaitMode(ByVal iWaitMode As Integer, ByVal i64CustomWaitTime_ps As Int64) As Boolean
    End Function

    <DllImport("DSOSDK.dll", EntryPoint:="uDsoSDKSetDelayTime")> _
    Public Shared Function uDsoSDKSetDelayTime(ByVal i64DelayTime_ps As Int64) As Boolean
    End Function

    <DllImport("DSOSDK.dll", EntryPoint:="uDsoSDKSetHoldoffTime")> _
    Public Shared Function uDsoSDKSetHoldoffTime(ByVal i64HoldOffTime_ps As Int64) As Boolean
    End Function

    <DllImport("DSOSDK.dll", EntryPoint:="uDsoSDKSetTrigPos")> _
    Public Shared Function uDsoSDKSetTrigPos(ByVal i64TrigPosition As Int64) As Boolean
    End Function

    'Trigger Setting
    <DllImport("DSOSDK.dll", EntryPoint:="uDsoSDKSetEdgeTrig")> _
    Public Shared Function uDsoSDKSetEdgeTrig(ByVal iCh As Integer, ByVal iSlope As Integer, ByVal i64Threshold_uV As Int64) As Boolean
    End Function

    <DllImport("DSOSDK.dll", EntryPoint:="uDsoSDKSetVideoTrig")> _
    Public Shared Function uDsoSDKSetVideoTrig(ByVal iCh As Integer, ByVal iMode As Integer, ByVal iScanline As Integer) As Boolean
    End Function

    <DllImport("DSOSDK.dll", EntryPoint:="uDsoSDKSetRuntTrig")> _
    Public Shared Function uDsoSDKSetRuntTrig(ByVal iCh As Integer, ByVal iPolarity As Integer, ByVal iCompareType As Integer, ByVal iEqualRange As Integer, ByVal i64Width_ps As Int64, ByVal i64Threshold1_uV As Int64, ByVal i64Threshold2_uV As Int64) As Boolean
    End Function

    <DllImport("DSOSDK.dll", EntryPoint:="uDsoSDKSetWidthTrig")> _
    Public Shared Function uDsoSDKSetWidthTrig(ByVal iCh As Integer, ByVal iPolarity As Integer, ByVal iCompareType As Integer, ByVal iEqualRange As Integer, ByVal i64Width_ps As Int64, ByVal i64Threshold_uV As Int64) As Boolean
    End Function

    <DllImport("DSOSDK.dll", EntryPoint:="uDsoSDKSetPatternTrig")> _
    Public Shared Function uDsoSDKSetPatternTrig(ByVal iSrcA As Integer, ByVal iSrcB As Integer, ByVal iNotA As Integer, ByVal iNotB As Integer, ByVal iAndOr As Integer, ByVal i64Width_ps As Int64, ByVal i64ThresholdA_uV As Int64, ByVal i64ThresholdB_uV As Int64) As Boolean
    End Function

    <DllImport("DSOSDK.dll", EntryPoint:="uDsoSDKSetStateTrig")> _
    Public Shared Function uDsoSDKSetStateTrig(ByVal iSrcA As Integer, ByVal iSrcB As Integer, ByVal iNotA As Integer, ByVal iNotB As Integer, ByVal iAndOr As Integer, ByVal i64ThresholdA_uV As Int64, ByVal i64ThresholdB_uV As Int64) As Boolean
    End Function

    <DllImport("DSOSDK.dll", EntryPoint:="uDsoSDKSetting")> _
    Public Shared Function uDsoSDKSetting(ByVal iCh As Integer, ByVal iItem As Integer, ByVal iValue As Int64) As Boolean
    End Function


    'Capture & Read Functions
    <DllImport("DSOSDK.dll", EntryPoint:="uDsoSDKCaptureEx")> _
    Public Shared Function uDsoSDKCaptureEx() As Boolean
    End Function

    <DllImport("DSOSDK.dll", EntryPoint:="uDsoSDKReadDbl_mv")> _
    Public Shared Function uDsoSDKReadDbl_mv(ByVal iDev As Integer, ByRef iFlag As IntPtr, ByVal lpdbDst As Double(), ByVal iProbe As Integer()) As Boolean
    End Function

    <DllImport("DSOSDK.dll", EntryPoint:="uDsoSDKReadDbl_uv")> _
    Public Shared Function uDsoSDKReadDbl_uv(ByVal iDev As Integer, ByRef iFlag As IntPtr, ByVal lpdbDst As Double(), ByVal iProbe As Integer()) As Boolean
    End Function

    <DllImport("DSOSDK.dll", EntryPoint:="uDsoSDKStop")> _
    Public Shared Function uDsoSDKStop() As Boolean
    End Function

    <DllImport("DSOSDK.dll", EntryPoint:="uDsoSDKGetStatus")> _
    Public Shared Function uDsoSDKGetStatus(ByVal iDev As Integer) As Integer
    End Function

    <DllImport("DSOSDK.dll", EntryPoint:="uDsoSDKDataReady")> _
    Public Shared Function uDsoSDKDataReady() As Boolean
    End Function

    <DllImport("DSOSDK.dll", EntryPoint:="uDsoSDKForceTrig")> _
    Public Shared Function uDsoSDKForceTrig() As Boolean
    End Function


    'Capture Paramentter Reading function
    <DllImport("DSOSDK.dll", EntryPoint:="uDsoSDKGetDeviceCount")> _
    Public Shared Function uDsoSDKGetDeviceCount() As Integer
    End Function

    <DllImport("DSOSDK.dll", EntryPoint:="uDsoSDKGetChOnOff")> _
    Public Shared Function uDsoSDKGetChOnOff(ByVal iCh As Integer) As Boolean
    End Function

    <DllImport("DSOSDK.dll", EntryPoint:="uDsoSDKGetBWL")> _
    Public Shared Function uDsoSDKGetBWL(ByVal iCh As Integer, ByRef iBwl As IntPtr) As Boolean
    End Function

    <DllImport("DSOSDK.dll", EntryPoint:="uDsoSDKGetCoupling")> _
    Public Shared Function uDsoSDKGetCoupling(ByVal iCh As Integer, ByRef iCoupling As IntPtr) As Boolean
    End Function

    <DllImport("DSOSDK.dll", EntryPoint:="uDsoSDKGetAcquireMode")> _
    Public Shared Function uDsoSDKGetAcquireMode(ByVal iCh As Integer, ByRef iAcquireMode As IntPtr) As Boolean
    End Function

    <DllImport("DSOSDK.dll", EntryPoint:="uDsoSDKGetTrigCouple")> _
    Public Shared Function uDsoSDKGetTrigCouple(ByRef iTrigCoupleFlag As IntPtr) As Boolean
    End Function

    <DllImport("DSOSDK.dll", EntryPoint:="uDsoSDKGetVoltDiv")> _
    Public Shared Function uDsoSDKGetVoltDiv(ByVal iCh As Integer, ByRef iVoltDiv_uV As IntPtr) As Boolean
    End Function

    <DllImport("DSOSDK.dll", EntryPoint:="uDsoSDKGetVoltPos")> _
    Public Shared Function uDsoSDKGetVoltPos(ByVal iCh As Integer, ByRef iPosition As IntPtr) As Boolean
    End Function

    <DllImport("DSOSDK.dll", EntryPoint:="uDsoSDKGetVoltOfs")> _
    Public Shared Function uDsoSDKGetVoltOfs(ByVal iCh As Integer, ByRef iVoltOfs_uV As IntPtr) As Boolean
    End Function

    <DllImport("DSOSDK.dll", EntryPoint:="uDsoSDKGetSampleRate")> _
    Public Shared Function uDsoSDKGetSampleRate(ByRef i64SampleRate As IntPtr) As Boolean
    End Function

    <DllImport("DSOSDK.dll", EntryPoint:="uDsoSDKGetRecordLength")> _
    Public Shared Function uDsoSDKGetRecordLength(ByRef iRecordLength As IntPtr) As Boolean
    End Function

    <DllImport("DSOSDK.dll", EntryPoint:="uDsoSDKGetWaitMode")> _
    Public Shared Function uDsoSDKGetWaitMode(ByRef iWaitMode As IntPtr, ByRef i64CustomWaitTime_ps As IntPtr) As Boolean
    End Function

    <DllImport("DSOSDK.dll", EntryPoint:="uDsoSDKGetDelayTime")> _
    Public Shared Function uDsoSDKGetDelayTime(ByRef i64DelayTime_ps As IntPtr) As Boolean
    End Function

    <DllImport("DSOSDK.dll", EntryPoint:="uDsoSDKGetHoldoffTime")> _
    Public Shared Function uDsoSDKGetHoldoffTime(ByRef i64HoldOffTime_ps As IntPtr) As Boolean
    End Function

    <DllImport("DSOSDK.dll", EntryPoint:="uDsoSDKGetTrigPos")> _
    Public Shared Function uDsoSDKGetTrigPos(ByRef i64TrigPosition As IntPtr) As Boolean
    End Function

    <DllImport("DSOSDK.dll", EntryPoint:="uDsoSDKGetHwBit")> _
    Public Shared Function uDsoSDKGetHwBit(ByRef iHwBit As IntPtr) As Boolean
    End Function



End Class
